var currentDialog = null;
var defaultModalFeatures = "width=950,height=700,scrollbars,resizable";

function doFeatures(features) {
	if (!features) {
		features = defaultModalFeatures;
	}

	var sh = screen.availHeight;
	var sw = screen.availWidth;
	
	var hFloor = getDimension("height", features);
	var wFloor = getDimension("width", features);
	
	var h = Math.min(hFloor, Math.round(sh * 0.8));
	var w = Math.min(wFloor, Math.round(sw * 0.8));

	var y = Math.round((sh - h)/2); 
	var x = Math.round((sw - w)/2);

	features += ",height=" + h;
	features += ",width="  + w;
	features += ",screenY=" + y;
	features += ",screenX=" + x;
	features += ",left=" + x
	features += ",top=" + y;
	
	return features;

}

function openModal(url, windowName, features, post) {
	closeModal();
	
	url = url.replace(/\|/g, "%7C");

   var dialog;
   if (post || url.length > 900) {
      var f = prepareUtilForm(url);
      f.method = "post";
      f.target = windowName;
      dialog = window.open('preWait.jsp', windowName, doFeatures(features));
      f.submit(); // submit into the open window
   } else {
      dialog = window.open(url, windowName, doFeatures(features));
   }
   setModalDialog(dialog);

	return dialog;
}

function setModalDialog(dialog) {
	currentDialog = dialog;
	
	if (currentDialog) {
	   Event.observe(window, "focus", focusOnModal);
	   Event.observe(window, "unload", closeModal);
   	focusOnModal();
	}
}

function focusOnModal() {
    if (currentDialog != null) {
    	try {
	        if (currentDialog.closed) {
	            clearCurrent();
	        } else {
	            currentDialog.focus();
	            // does our modal dialog also have a modal dialog?
	            if (currentDialog.focusOnModal && currentDialog.currentDialog != null) {
	            	currentDialog.focusOnModal();
	            }
	        }
	     } catch (err) {
            clearCurrent();
	     }
    }
}

function closeModal(windowName) {
   try {
      if (currentDialog != null) {
         if (windowName && (windowName.constructor === String) && (currentDialog.name != windowName)) {
            // current dialog name does not match the window name to close
            return;
         }
         if (currentDialog.allowParentToClose === undefined ||
             currentDialog.allowParentToClose()) 
         {
            currentDialog.close();
            clearCurrent();
         }
      }
   } catch (err) {
   }
}

function clearCurrent() {
   if (currentDialog)
   {
      Event.stopObserving(window, "focus", focusOnModal);
   }
   
   currentDialog = null;
}

function getDimension(dimension,features)
{
	var f = new String(features);
	var pos = f.indexOf(dimension);
	var tempStr = f.substring(pos, f.length);
	var pos = tempStr.indexOf("=");
	var pos1 = tempStr.indexOf(",");

	if(pos1==-1)
		h=tempStr.substring(pos+1,tempStr.length);
	else
		h=tempStr.substring(pos+1,pos1);
	return h;
}

function popupHelpAction(action,context,loc) {

   var url = context+"/helpSection.jsp?action="+action+"&locale="+loc;
   var features = "width=825,height=550,scrollbars,resizable";

   window.open(url, "popupHelp", doFeatures(features));
      
}

function getWindowPath(win) {
	if (!win) {
		win = window;
	}
	var path = "";
	var winName = win.name;
	while (win.name != "" && win.top != win) {
		if (path.length > 0) {
			path = "." + path;
		}
		path = winName + path;
		win = win.parent;
	}
	return path;
}
