<%@ page import="java.util.*" %>
<%@ include file="/tiles/taglibs.jsp" %>

<%
	final Locale locale = request.getLocale();
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	String assessableTypeCd = (String)request.getAttribute("assessableTypeCd");
%>

<mon:Page template="popup">
   <mon:Head>
      <script type="text/javascript">
      var isMaxFunction = false;
      var maxExpressionText = "";
      
      function monitorInit() {
         initNSMenu();
         var expressionText = document.getElementById('expressionText'); 
         var existingText = expressionText.value;
         if (existingText.indexOf('MAX') != -1) {
            document.getElementById('maxButton').disabled = true;
            document.getElementById('parenthesisButton').disabled = true;
            isMaxFunction =true;
         }  
      }
      
      function append(selectionValue, existingText)
      {
        if (isMaxFunction) {
           if (   existingText.indexOf('(') != -1 && existingText.lastIndexOf(')') != -1) {
             maxExpressionText =  existingText.substring( existingText.indexOf('(') + 1, existingText.lastIndexOf(')') ) + selectionValue;          
            } else {
               maxExpressionText = existingText + selectionValue
            }
            return "MAX(" + maxExpressionText + ")"; 
        } else {
          return existingText + selectionValue;
        }
      }
      function enableMeasuresList(){
         document.getElementById('measuresList').disabled = false;
         document.getElementById('addButton').disabled = false;
      }
      function disableMeasuresList(){
            document.getElementById('measuresList').disabled = true;
            document.getElementById('addButton').disabled = true;
         }
      
      function doAdd()
      {
        var measuresList = document.getElementById('measuresList'); 
        if(measuresList.disabled!=true){
            var selection = measuresList.options[measuresList.selectedIndex];
            var expressionText = document.getElementById('expressionText');
            var existingText = expressionText.value;  
            expressionText.value = append(selection.value,existingText);
            disableMeasuresList();
        }
        
      }
      
      function doPlus() {
        var expressionText = document.getElementById('expressionText'); 
        var existingText = expressionText.value;
        expressionText.value = append("+",existingText);
        enableMeasuresList(); 
      }
      
      function doMinus() {  
        var expressionText = document.getElementById('expressionText');
        var existingText = expressionText.value;
        expressionText.value = append("-",existingText);
        enableMeasuresList();
       
      }
      
      function doMultiply() { 
        var expressionText = document.getElementById('expressionText');
        var existingText = expressionText.value;
        expressionText.value = append("*",existingText);
        enableMeasuresList();
      }
      
      function doDivide() { 
        var expressionText = document.getElementById('expressionText');
        var existingText = expressionText.value;
        expressionText.value = append("/",existingText);
        enableMeasuresList();
      }
      
      function doParenthesis() { 
        var selectedTxt = document.selection.createRange().text;
        if (selectedTxt != "") {
           var newTxt = "(" + selectedTxt + ")";
           document.selection.createRange().text = newTxt;  
        }
        else {  
           var expressionText = document.getElementById('expressionText'); 
           var existingText = expressionText.value; 
           expressionText.value = "(" + existingText + ")";
        }
        
      }
      
      function doErase() { 
        var expressionText = document.getElementById('expressionText'); 
        expressionText.value = "";
        enableMeasuresList();
        if (isMaxFunction) {
         document.getElementById('maxButton').disabled = false;
         document.getElementById('parenthesisButton').disabled = false;
         isMaxFunction = false;
        }
      }
      
      function doMax() {
        var expressionText = document.getElementById('expressionText'); 
        var existingText = expressionText.value;
        isMaxFunction = true;
        expressionText.value = append("",existingText);
        enableMeasuresList();
        document.getElementById('maxButton').disabled = true;
        document.getElementById('parenthesisButton').disabled = true;
      }
      
      function addComma() { 
        var expressionText = document.getElementById('expressionText');
        var existingText = expressionText.value;
        expressionText.value = append(",",existingText);
        enableMeasuresList();
      }
      
      function doSave() {
         
         document.forms[0].action="ExpressionEdit.do?method=save&assessableTypeCd=<%= StringUtil.escapeHTML(assessableTypeCd) %>";
         document.forms[0].submit()
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ExpressionEdit">               
         
         <mon:Content>
            <html:hidden property="handle" />
   <html:hidden property="variableName" />
   
   <table border="0" cellspacing="0" cellpadding="0" width="100%">
     <tr>
        <td width="40%">
        <table border="0" cellspacing="0" cellpadding="0" width="100%">
           <tr>
              <td class="label" align="center" width="40%">
               <mon:label 
               key="Measures.expressionEditor.availableMeasures.txt"
               property="measure" />
              </td>
           </tr>
           <tr>
              <td align="center">
               <html:select property="measure" size="10" styleId="measuresList" style="width: 97%" ondblclick="doAdd()">
            <html:options collection="measures" property="id" labelProperty="id" />
      </html:select> 
              </td>
           </tr>
        </table>
        </td>
        <td>
           <table border="0" cellspacing="0" cellpadding="0" width="100%">
           <tr>
           <td align="center">
            <input type="button" class="button"
         id="addButton"
      onmouseover="this.className='button buttonRollover'"
      onmouseout="this.className='button'"
      value="<fmt:message key='Measures.expressionEditor.addButton.txt' />"
      onclick="doAdd();" />
           </td>
           </tr>
           </table>
        </td>
        <td>
        <table border="0" cellspacing="0" cellpadding="0" width="100%">
        <tr>
           <td class="label" align="center" width="40%">
               <mon:label
               key="Measures.expressionEditor.expression.txt"
                  property="expression" />
           </td>
        </tr>
        <tr>
           <td align="center">
            <html:textarea 
               property="expression"
               styleId="expressionText"
      style="width:97%" rows="8" />
         
           </td>
        </tr>
        </table>
      </td>
   </tr>
   <tr>
      <td colspan="2"/>
      <td align="center">
   <input type="button" class="button"
         id="maxButton"
      onmouseover="this.className='button buttonRollover'"
      onmouseout="this.className='button'"
      value="<fmt:message key='Measures.expressionEditor.maxButton.txt' />"
      onclick="doMax();" />
   <input type="button" class="button"
         id="commaButton"
      onmouseover="this.className='button buttonRollover'"
      onmouseout="this.className='button'"
      value="<fmt:message key='Measures.expressionEditor.commaButton.txt' />"
      onclick="addComma();" />
   <input type="button" class="button"
         id="plusButton"
      onmouseover="this.className='button buttonRollover'"
      onmouseout="this.className='button'"
      value="<fmt:message key='Measures.expressionEditor.plusButton.txt' />"
      onclick="doPlus();" />
   <input type="button" class="button"
         id="minusButton"
      onmouseover="this.className='button buttonRollover'"
      onmouseout="this.className='button'"
      value="<fmt:message key='Measures.expressionEditor.minusButton.txt' />"
      onclick="doMinus();" />
   <input type="button" class="button"
         id="multiplyButton"
      onmouseover="this.className='button buttonRollover'"
      onmouseout="this.className='button'"
      value="<fmt:message key='Measures.expressionEditor.multiplyButton.txt' />"
      onclick="doMultiply();" />
   <input type="button" class="button"
         id="divideButton"
      onmouseover="this.className='button buttonRollover'"
      onmouseout="this.className='button'"
      value="<fmt:message key='Measures.expressionEditor.divideButton.txt' />"
      onclick="doDivide();" />
   <input type="button" class="button"
         id="parenthesisButton"
      onmouseover="this.className='button buttonRollover'"
      onmouseout="this.className='button'"
      value="<fmt:message key='Measures.expressionEditor.parenthesisButton.txt' />"
      onclick="doParenthesis();" />
   <input type="button" class="button"
         id="eraseButton"
      onmouseover="this.className='button buttonRollover'"
      onmouseout="this.className='button'"
      value="<fmt:message key='Measures.expressionEditor.eraseButton.txt' />"
      onclick="doErase();" />
      
     </td>
   </tr>
 </table>

<c:if test="${saveAndClose}" >
   <script type="text/javascript">
      var expressionText = document.getElementById('expressionText');
      var parentWindow = window.opener.document;
      var obj = parentWindow.getElementById('computationFn');
      obj.value = expressionText.value;
      window.close();
   </script>
</c:if>
         </mon:Content>   
         
         <mon:PopupButtonBar>
            <mon:Button id="submitButton" onclick="doSave();">
               <fmt:message key='okButton.txt' />
            </mon:Button>
               
            <mon:Button id="cancelButton" onclick="window.close();">
               <fmt:message key='cancelButton.txt' />
            </mon:Button>  
         </mon:PopupButtonBar>
      </html:form>      
   </mon:Body>
</mon:Page>
             