<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%    
    final Locale locale = request.getLocale();
    final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
    final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
    boolean canCreate = SecurityUtils.canDoSomewhere(Do.CREATE, PotentialImpact.object, psession);
    boolean canDelete = SecurityUtils.canDoSomewhere(Do.DELETE, PotentialImpact.object, psession);
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      <%-- not needed for now
      var statusMap = new Array();
      --%>
      
      function setDimAreaHandle(daHandle) {
         beginWait();
         document.forms.queryForm.submit();
         return false;
      }
      
      function createImpact() {
         var f = document.forms.queryForm;
         f.action = "<%= request.getContextPath() %>/PotentialImpact.do?method=create";
         f.location.value = f.TCArea.value;
         f.submit();
      }
      
      function createNewImpactFrom(handle) {
         var f = document.forms.queryForm;
         f.action = "<%= request.getContextPath() %>/PotentialImpact.do?method=createNew&handle=" + encodeURI(handle);
         f.submit();
      }
      
      function deleteImpact(handle, name) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
            "potentialImpacts.delete.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, unescape(name));
         if (confirm(msg)) {
            goImpact("delete", handle, false);
         }
      }
      
      function goImpact(method, handle, showWaitDialog) {
         if (showWaitDialog) {
            beginWait();
         }
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/PotentialImpact.do"
               + "?method=" + method
               + "&handle=" + encodeURI(handle);
         document.forms.queryForm.submit();
      }
      
      function showContextMenu(handle, name) {
         var menu = new TableMenu();
         
         menu.addMenuItem(
               new MenuItem(
                  MenuItem.prototype.action,
                  "<fmt:message key='application.createNewFrom.image'/>", 
                  "<fmt:message key='application.createNewFrom.txt'/>", 
                  "javascript:createNewImpactFrom('" + handle + "')",
                  <%= canCreate %>));
            menu.addMenuItem(
               new MenuItem(
                  MenuItem.prototype.action,
                  "<fmt:message key='application.delete.image'/>", 
                  "<fmt:message key='application.delete.txt'/>", 
                  "javascript:deleteImpact('" + handle + "','" + name + "')",
                  <%= canDelete %>));
         menu.render();
         return false;
      }
      
      TableComponent.prototype.getQueryEditorURL = function()
      {
         var busObjForNamedList=  this.tableParameters.getBusinessObjectTypeForNamedLists();
         return "QueryEditor.do?entryId=" + this.entryName + "&busObjForNamedList=potentialImpact"
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/PotentialImpactQuery">
         <mon:ToolBar>
            <c:if test="${canCreate}">
                  <a class="toolBarAction" href="#" id="createPotentialImpactLink" onclick="createImpact(); return false;"><fmt:message key='potentialImpacts.create.button.txt'/></a>
            </c:if>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="impact" disableTableActions="true" >
            <mon:title><fmt:message key="potentialImpacts.title.txt"/></mon:title>
            <%
               final PotentialImpactEx impact = (PotentialImpactEx)pageContext.findAttribute("impact");
               final String handle = impact == null? "": impact.getHandleString();
               final String impactName = impact == null? "": impact.getImpactNm();
            %>
               <c:if test="${canDelete or canCreate}">
                  <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
                  &nbsp;<a id="contextMenu" href="#" onclick="return showContextMenu('<%= handle %>', '<%= ParsingUtils.escape(impactName) %>')"
                  ><img border="0"
                      src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                      alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                      title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                   /></a>&nbsp;
                  </mon:fixedColumn>
               </c:if>
               
            </mon:tableComponent>
            <input type="hidden" name="location" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
