<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.cpb.MonitorUIDefinitionType"%>
<%@ page import="com.sas.oprisk.server.logical.DimensionalAreaHandle"%>
<%@ page import="com.sas.oprisk.monitor.web.riskInstance.*" %>
<%@ page import="com.sas.oprisk.monitor.web.utils.*" %>
<%@ page import="com.sas.oprisk.monitor.web.cpb.util.UIContextUtil"%>
<%@ page import="com.sas.oprisk.server.web.cpb.runtime.MonitorUIContext"%>
<%@ page import="com.sas.solutions.cpb.runtime.UIContext"%>
<%@ page import="com.sas.oprisk.monitor.web.csa.assessment.ratingsSummary.RatingsSummaryModel"%>
<%@ include file="/tiles/taglibs.jsp" %>
<%
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final RiskInstanceCPBModel model = (RiskInstanceCPBModel)request.getAttribute("model");
   final RatingsSummaryModel rsumModel = model.getRatingsSummaryModel();
   
   final UIContext uiContext = UIContextUtil.getUIContext(request);
   final RiskInstance ri = (RiskInstance)uiContext.getValue(MonitorUIContext.DefaultField.BUSINESS_OBJECT.getName());
   
   final DimensionalAreaHandle areaHandle = 
      (DimensionalAreaHandle)uiContext.getValue(MonitorUIDefinitionType.VAR_LOCATION);
   final String areaHandleStr = areaHandle == null ? "" : areaHandle.toString(); 
   final boolean screenReadOnly;
    //If this is a create action then never allow the form to not be read-only. 
    if(request.getAttribute(RiskInstanceCPBAction.IS_CREATE_RISK_ATTRIBUTE) != null && (Boolean)request.getAttribute(RiskInstanceCPBAction.IS_CREATE_RISK_ATTRIBUTE)) {
       screenReadOnly = false;
    } else { 
      screenReadOnly = model.isRatingsReadOnly() && (model.isReadOnly() &&  (rsumModel == null || rsumModel.isResponseReadOnly())); 
   }
   request.setAttribute("screenReadOnly",Boolean.valueOf(screenReadOnly));
   
%>

<c:set var="template">
   <c:out value="${uiContext.popup ? 'popup' : 'details' }"/>
</c:set>

<mon:Page template="${template}">
   <mon:Head>
      <mon:include js="/dwr/engine.js" />
      <mon:include js="/dwr/interface/MonitorServer.js" />
      <mon:include js="/dwr/interface/RCSAService.js" />
      
      <script type="text/javascript">
      
      function callMethod(method, workflowStatusId) {
         var f = document.forms[0];
         if (!method) 
         {
            method = 'save';
         }
         f.action = "<%= request.getContextPath() %>/RiskInstance.do?method=" + method;
         if (workflowStatusId)
         {
            f.action += "&<%= WorkflowWebUtil.PARAM_WORKFLOW_STATUS_ID %>=" + workflowStatusId;
         }
         f.submit();
      }
      <%-- forward to specified page --%>
      function forward(path) {
         callMethod("forward&path=" + escape(path));
      }
      function doPopupClose() {
         doRiskInstance("popupClose");
      }
      function popupCloser_refresh() {
         doRiskInstance("refresh");
      }
      function doRiskInstance(method, anchor) {
         var f = document.forms[0];
         f.action = "<%= request.getContextPath() %>/RiskInstance.do"
            + "?method=" + method;
            
         if (anchor) {
            f.action = f.action + "#" + anchor;
         }
         f.submit();
      }
      
      function getInstanceArea() {
      var f = document.forms[0];
	      if (f['TEMP.LOCATIONHANDLE']){
	  		return f['TEMP.LOCATIONHANDLE'].value;   
	      }else if (f.LOCATION) {
	         return f.LOCATION.value;
	      } else {
	         return '<%= areaHandleStr %>';
	      }
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/RiskInstance">      
         <c:if test="${template == 'details'}">
         <mon:ToolBar>
            <c:choose>
               <c:when test="${screenReadOnly}">
                  <c:choose>
                     <c:when test="${uiContext.popup}">
                        <mon:Button name="actionButtonCancel" onclick="window.close()">
                           <fmt:message key="application.button.done.txt" />
                        </mon:Button>
                     </c:when>
                     <c:otherwise>
                        <c:forEach var="labelValue" items="${model.statusLabelValues}" varStatus="status">      
                           <mon:Button name="actionButton${status.count}" onclick="lockCommandButtons(); beginWait(); callMethod('${model.activityCallMethod}', '${labelValue.value}')">
                              <c:out value="${labelValue.label}"/>
                           </mon:Button>    
                        </c:forEach>
                        
                        <mon:Button name="actionButtonCancel" onclick="callMethod('cancel')">
                           <fmt:message key="application.button.done.txt" />
                        </mon:Button>
                     </c:otherwise>
                  </c:choose>               
               </c:when>
               <c:otherwise>
                  <mon:Button name="actionButtonSave" onclick="callMethod('save')">
                     <fmt:message key="application.button.save.txt" />
                  </mon:Button>                
                        
                  <c:if test="${((empty uiContext['assessment.handle']) and (empty uiContext['assessmentTemplate.handle'])) 
                            or not empty uiContext['ratingsSummary.handle']}"> 
                     <mon:Button name="actionButtonApply" onclick="callMethod('apply')">
                        <fmt:message key="application.button.apply.txt" />
                     </mon:Button>                                       
                  </c:if>
                  
                  <c:forEach var="labelValue" items="${model.statusLabelValues}" varStatus="status">      
                     <mon:Button name="actionButton${status.count}" onclick="lockCommandButtons(); beginWait(); callMethod('${model.activityCallMethod}', '${labelValue.value}')">
                        <c:out value="${labelValue.label}"/>
                     </mon:Button>    
                  </c:forEach>
                  
                  <mon:Button name="actionButtonCancel" onclick="callMethod('cancel')">
                     <fmt:message key="application.button.cancel.txt" />
                  </mon:Button>
               </c:otherwise>
            </c:choose>
         </mon:ToolBar>
         </c:if>
         
         <mon:Content>
            <input type="hidden" name="riHandle" value="<c:out value="${uiContext.handle}" />" />
            <input type="hidden" name="tpHandle" value="<c:out value="${uiContext.tpHandle}" />" />
            
            <c:if test="${not empty riskInstanceCPBForm.qnrHandle}"> 
               <mon:hidden property="qnrHandle" />
            </c:if>  
            
            <%-- render the screen --%>
            <cpb:screen screenID="riskInstance" readOnly="<%= screenReadOnly %>" />
         </mon:Content>   
         
         <c:if test="${template == 'popup' }">
         <mon:PopupButtonBar>
            <c:choose>
               <c:when test="${screenReadOnly }">
                  <c:choose>
                     <c:when test="${uiContext.popup}">
                        <mon:Button name="actionButtonCancel" onclick="window.close()">
                           <fmt:message key="application.button.done.txt" />
                        </mon:Button>
                     </c:when>
                     <c:otherwise>
                        <mon:Button name="actionButtonCancel" onclick="callMethod('cancel')">
                           <fmt:message key="application.button.done.txt" />
                        </mon:Button>
                     </c:otherwise>
                  </c:choose>               
               </c:when>
               <c:otherwise>
                  <mon:Button name="actionButtonSave" onclick="callMethod('save')">
                     <fmt:message key="application.button.save.txt" />
                  </mon:Button>                
                        
                  <c:if test="${((empty uiContext['assessment.handle']) and (empty uiContext['assessmentTemplate.handle'])) 
                            or not empty uiContext['ratingsSummary.handle']}"> 
                     <mon:Button name="actionButtonApply" onclick="callMethod('apply')">
                        <fmt:message key="application.button.apply.txt" />
                     </mon:Button>                                       
                  </c:if>  
                  
                  <mon:Button name="actionButtonCancel" onclick="callMethod('cancel')">
                     <fmt:message key="application.button.cancel.txt" />
                  </mon:Button>
               </c:otherwise>
            </c:choose>            
         </mon:PopupButtonBar>
         </c:if>
      </html:form>
      
      <c:if test="${not empty riskInstanceCPBForm.qnrHandle}">
      <script language="javascript">
      // Override default 360 link anchor behavior for potential impacts during an assessment of a Risk (ratings component is on the page).
      LinkedBusinessObjects.oldViewLinkInstance = LinkedBusinessObjects.viewLinkInstance;
      LinkedBusinessObjects.viewLinkInstance = function(key)
      {
         if (key && key.indexOf("potentialImpact") != -1)
         {
            key = decodeURI(key);
            var path = "/PotentialImpact.do"
              + "?method=select"
              + "&handle=" + key.substring(key.indexOf("|")+1)+"|"
              + "&riHandle=" + document.forms[0].riHandle.value
              + "&qnrHandle=<c:out value="${riskInstanceCPBForm.qnrHandle}"/>" 
              <c:if test="${model.readOnly}">+ "&readOnly=true"</c:if>
              <c:if test="${not empty uiContext.pointInTime}">+ "&pointInTime=<c:out value="${uiContext.pointInTime}"/>"</c:if>;
            
            path = escape(path);
            doRiskInstance("forward&path=" + path + "");
         }
         else
         {
            LinkedBusinessObjects.oldViewLinkInstance(key);
         }
      };
      </script>
      </c:if>
            
   </mon:Body>
</mon:Page>