<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.RCSAGeneralModel" %>
<%@ page import="com.sas.oprisk.server.base.RiskExSourceCd" %>
<%@ page import="com.sas.oprisk.server.RiskInstance" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%    
	final Locale locale = request.getLocale();
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	request.setAttribute("assessmentSource", RiskExSourceCd.assessment);
   
   // map of TableCellFormatter by (String)fieldName - colFormatters have all measure columns
   Map colFormatters = (Map)request.getAttribute("colFormatters");
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      <%-- not needed for now
      var statusMap = new Array();
      --%>
      
      function viewAssessment(assessmentHandle) {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/AssessmentWizard.do"
               + "?method=view"
               + "&handle=" + assessmentHandle;
         f.submit();
      }
      
      function setDimAreaHandle(daHandle) {
         beginWait();
         document.forms.queryForm.submit();
         return false;
      }
      
      function createRiskInstance() {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/RiskInstance.do"
               + "?method=create";
         f.location.value = f.TCArea.value;
         f.submit();
      }
      
      function deleteRiskInstance(handle, name) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
            "RiskInstance.delete.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, unescape(name));
         if (confirm(msg)) {
            goRiskInstance("delete", handle, false);
         }
      }
      
      function goRiskInstance(method, handle, showWaitDialog) {
         if (showWaitDialog) {
            beginWait();
         }
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/RiskInstance.do"
               + "?method=" + method
               + "&handle=" + encodeURI(handle);
         document.forms.queryForm.submit();
      }
      
      function showContextMenu(handle, name) {
         var menu = new TableMenu();
         <c:choose>
         <c:when test="${canDelete}">
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<fmt:message key='application.delete.image'/>", "<fmt:message key='application.button.delete.txt'/>", "javascript:deleteRiskInstance('" + handle + "', '" + name + "')"));
         </c:when>
         <c:otherwise>
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<fmt:message key='application.deletedisabled.image'/>", "<fmt:message key='application.button.delete.txt'/>", "return false;",false));
         </c:otherwise>
         </c:choose>
         menu.render();
         return false;
      }
      
      function editRiskProfile() {
         var f = document.forms.queryForm;
         f.action =
           "<%= request.getContextPath() %>/RiskProfileEdit.do?location=" + f.TCArea.value;
         f.submit();
      }
      
       TableComponent.prototype.getQueryEditorURL = function()
       {
          var busObjForNamedList=  this.tableParameters.getBusinessObjectTypeForNamedLists();
          return "QueryEditor.do?entryId=" + this.entryName + "&busObjForNamedList=risk"
       }
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/RiskInstanceQuery">      
         <mon:ToolBar>
            <c:if test="${canCreate}">
               <a class="toolBarAction" href="#" id="createRiskInstanceLink" onclick="createRiskInstance(); return false;"><%= bundle.getString("riskInstance.create.txt") %></a>
            </c:if>
            <mon:SavedView ></mon:SavedView>
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="riskInstance" columnFormatters="<%=colFormatters%>" disableTableActions="true" >
            <mon:title><fmt:message key="RCSAGeneral.step.risks.txt"/></mon:title>
            
             
         <%
             final RiskInstanceEx riskInstance = (RiskInstanceEx)pageContext.findAttribute("riskInstance");
             if (riskInstance != null) 
             {
                 final String riskInstNm = ParsingUtils.escape(riskInstance.getRiskNm());
                 final RiskInstance instance = RiskInstance.object.fetchIfExists(riskInstance.getRiskRk(), psession);
                 if (instance != null)
                 {
                 final Boolean isPartial = new Boolean(instance.isPartial(psession));
                 pageContext.setAttribute("isPartial", isPartial);
                 Boolean assessmentIsAccessible = new Boolean("false");
                 HashSet assessmentsICanAccess=(HashSet)request.getAttribute("assessmentsICanAccess");
                 if (riskInstance.getAssessmentTaggedPointerHandle()!=null)
                 {
                      Long assessmentRk=riskInstance.getAssessmentTaggedPointerHandle().getPointer();
                      if (assessmentsICanAccess.contains(assessmentRk))
                      {
                          assessmentIsAccessible = new Boolean("true");
                      }
                 }
                 pageContext.setAttribute("assessmentIsAccessible", assessmentIsAccessible);
             }
         %>
            
               <c:if test="${canDirectEdit && canCreate && canAssess}">
                   <mon:fixedColumn width="1%">
                     <c:if test="${!isPartial}">
                        <mon:action href="javascript:editRiskProfile();"><fmt:message key='riskManagement.riskProfile.editRiskProfile.txt'/></mon:action>
                        <input type="checkbox" name="risks" value="<c:out value='${riskInstance.handleString}'/>"/>
                     </c:if>
                  </mon:fixedColumn>
               </c:if>
         
             <c:if test="${canDelete or canCreate}">
            <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
         
               &nbsp;<a id="contextMenu" href="#" onclick="return showContextMenu('<c:out value='${riskInstance.handleString}'/>', '<%= riskInstNm %>')"
               ><img border="0"
                   src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                  alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                  title="<fmt:message key='application.rowActions.tooltip.txt'/>"
               /></a>&nbsp;
            </mon:fixedColumn>
             </c:if>
         
            <mon:fixedColumn width="1%" title='<%= bundle.getString("riskManagement.irm.assessment.txt") %>' before="false">
               <c:if test="${riskInstance.riskExSourceCd == assessmentSource && assessmentIsAccessible}">
                 <a href="javascript:viewAssessment('<c:out value='${riskInstance.assessmentHandle}'/>')">
               </c:if>
               <c:out value='${riskInstance.assessmentName }'/>
               <c:if test="${riskInstance.riskExSourceCd == assessmentSource && assessmentIsAccessible}">
                 </a>
               </c:if>
            </mon:fixedColumn>
         <%
             }
         %>
         
         </mon:tableComponent>
         
         <input type="hidden" name="location" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
