<%@ include file="/tiles/taglibs.jsp" %>


<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.RCSAGeneralModel" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%    
     Locale locale = request.getLocale();
     ResourceBundle bundle = ApplicationProperties.getBundle(locale);
     PersistenceSession psession = MonitorContext.getPersistenceSession(request);
%>

<mon:Page template="default">
   <mon:Head>
      <mon:include js="/script/modalPopup.js" />
      <mon:include js="/ext/cpbcore/browser/Event.js" />
      <script type="text/javascript">
      
      function getForm() {
         return document.forms.questionnaireTemplateQueryForm;
      }
      
      function setDimAreaHandle(dpHandle) {
         beginWait();
         getForm().submit();
         return false;
      }
      
      function createScenario() {
         var f = getForm();
         f.action =
            "<%= request.getContextPath() %>/ScenarioTemplateWizard.do" 
            + "?method=editScenario";
         f.dimensionalArea.value = f.TCArea.value;
         f.submit();
      }
      
      function deleteScenario(handle, name) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
               "ScenarioTemplate.delete.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, unescape(name));
         if (confirm(msg)) {
            goTemplate("delete", handle);
         }
      }
      
      function previewScenario(handle) {
         goTemplate("preview", handle);
      }
      
      function goTemplate(method, handle) {
         beginWait();
         var f = getForm();
         f.action = "<%= request.getContextPath() %>/ScenarioTemplate.do"
            + "?method=" + method
            + "&handle=" + encodeURI(handle);
         f.submit();
      }
      
      function applyFilter() {
         getTableComponent().tableParameters.setStart(0);
         getForm().submit();
      }      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ScenarioTemplateQuery">      
         <mon:ToolBar>
            <c:if test="${canCreate}">
               <a class="toolBarAction" href="#" id="createScenarioTemplateLink" onclick="createScenario(); return false;"><fmt:message key='RCSAGeneral.scenarios.create.txt'/></a>
            </c:if>
            <mon:SavedView></mon:SavedView>
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="template" disableTableActions="true" >
               <mon:title><fmt:message key="RCSAGeneral.step.scenarios.txt"/></mon:title>
               
            <mon:filter> <!-- begin status filter -->
               <fmt:message key="application.status.txt"/>:&nbsp;
               
               <html:select property="filterType">
                  <html:option value="all"><fmt:message key='application.all.txt'/></html:option>
                  <html:option value="active"><fmt:message key='application.active.txt'/></html:option>
                  <html:option value="inactive"><fmt:message key='application.inactive.txt'/></html:option>
               </html:select>
                  
               &nbsp;&nbsp;
               
               <input type="button" class="button"
                  onmouseover="this.className='button buttonRollover'"
                  onmouseout="this.className='button'"
                  value="&nbsp;<fmt:message key='goButton.txt' />&nbsp;" 
                  onclick="applyFilter()" />
                  
               <br/><br/>
            </mon:filter> <!-- end status filter -->
                  
            <mon:fixedColumn width="1%" title='<%= bundle.getString("QuestionnaireTemplateWizard.step.preview.txt") %>' before="false">
               <a href="javascript:previewScenario('<c:out value='${template.handleString}'/>')">
                  <img border="0" src="<fmt:message key='application.preview.image'/>" /></a>
            </mon:fixedColumn>
               
            <c:if test="${canDelete}">
               <mon:fixedColumn width="1%" title='<%= bundle.getString("application.button.delete.txt") %>' before="false">
         <%
            final ScenarioEx template = (ScenarioEx)pageContext.findAttribute("template");
            final String escName = ParsingUtils.escape(template.getName());
         %>
                  <a href="#" onclick="deleteScenario('<c:out value='${template.handleString}'/>', '<%= escName %>')">
                     <img border="0" src="<fmt:message key='application.delete.image'/>" /></a>
               </mon:fixedColumn>
            </c:if>
         
           </mon:tableComponent>
         
         <input type="hidden" name="dimensionalArea" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>