<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.RCSAGeneralModel" %>
<%@ page import="com.sas.oprisk.server.base.AssessmentStatusCd" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%    
	final Locale locale = request.getLocale();
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      <%-- not needed for now
      var statusMap = new Array();
      --%>
      
      function setDimAreaHandle(daHandle) {
         beginWait();
         document.forms.queryForm.submit();
         return false;
      }
      
      function createScenario() {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/ScenarioWizard.do?method=create";
         f.location.value = f.TCArea.value;
         f.submit();
      }
      
      function createScenarioFrom(handle) {
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/ScenarioWizard.do"
               + "?method=createFrom"
               + "&handle=" + encodeURI(handle);
         document.forms.queryForm.submit();
      }
      
      function deleteScenario(handle, name) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
               "Scenarios.delete.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, unescape(unescape(name)));
         if (confirm(msg)) {
            goScenario("delete", handle);
         }
      }
      
      function goScenario(method, handle, showWaitDialog) {
         if (showWaitDialog) {
            beginWait();
         }
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/Scenarios.do"
               + "?method=" + method
               + "&handle=" + encodeURI(handle);
         document.forms.queryForm.submit();
      }
      
      function showContextMenu(handle, statusCd, name) {
         var nyo = '<%= AssessmentStatusCd.notYetOpen.getValue() %>' == statusCd;
         var open = '<%= AssessmentStatusCd.open.getValue() %>' == statusCd;
         var closed = '<%= AssessmentStatusCd.closed.getValue() %>' == statusCd;
         
         var menu = new TableMenu();
      
      <c:if test="${canUpdate}"> 
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= request.getContextPath() %>/" + (nyo ? "<fmt:message key='Assessments.open.image'/>" : "<fmt:message key='Assessments.disabled.image'/>"), 
            "<fmt:message key='Assessments.button.open.txt'/>", "javascript:goScenario('prepareToOpen', '" + handle + "')", 
            nyo));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= request.getContextPath() %>/" + (open ? "<fmt:message key='Assessments.close.image'/>" : "<fmt:message key='Assessments.disabled.image'/>"), 
            "<fmt:message key='Assessments.button.close.txt'/>", "javascript:goScenario('close', '" + handle + "', true)", 
            open));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= request.getContextPath() %>/" + (closed ? "<fmt:message key='Assessments.reopen.image'/>" : "<fmt:message key='Assessments.disabled.image'/>"), 
            "<fmt:message key='Assessments.button.reopen.txt'/>", "javascript:goScenario('reopen', '" + handle + "')", 
            closed));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
      </c:if>
      <c:if test="${canCreate}">
      
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<%= request.getContextPath() %>/<fmt:message key='application.createNewFrom.image'/>", "<fmt:message key='application.button.createNewFrom.txt'/>", "javascript:createScenarioFrom('" + handle + "')"));
      </c:if>
      <c:if test="${canDelete}">
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action, 
            "<%= request.getContextPath() %>/<fmt:message key='application.delete.image'/>", 
            "<fmt:message key='application.button.delete.txt'/>", 
            "javascript:deleteScenario('" + handle + "', '" + name + "')"));
      </c:if>
      <c:if test="${canCreate or canDelete}">
         menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
      </c:if>
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<%= request.getContextPath() %>/<fmt:message key='Assessments.viewQuestionnaires.image'/>", "<fmt:message key='Scenarios.button.viewScenarios.txt'/>", "javascript:goScenario('viewScenarios', '" + handle + "')"));
         menu.render();
         
         return false;
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ScenarioQuery">      
         <mon:ToolBar>
            <c:if test="${canCreate}">
               <a class="toolBarAction" href="#" id="createScenarioLink" onclick="createScenario(); return false;"><fmt:message key='Scenarios.button.new.txt'/></a>
            </c:if>
            <mon:SavedView></mon:SavedView>
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="assessment" disableTableActions="true" >
            
            <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
         <%
            final AssessmentEx assessment = (AssessmentEx)pageContext.findAttribute("assessment");
            // double escape name because it is going in an href
            final String escName = ParsingUtils.escape(ParsingUtils.escape(assessment.getName()));
         %>
               <a href="#" onclick="return showContextMenu('<c:out value='${assessment.handleString}'/>', '<c:out value='${assessment.assessmentStatusCd}'/>', '<%= escName %>')">
                  <img border="0" src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.image'/>" 
                     alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     title="<fmt:message key='application.rowActions.tooltip.txt'/>"
               /></a>
            </mon:fixedColumn>
         </mon:tableComponent>
         
         <input type="hidden" name="location" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
