<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.kri.indicators.*" %>
<%@ page import="java.util.*" %>
<%@page import="com.sas.oprisk.monitor.web.table.KriDecimalsCellFormatter"%>
<%
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final IndicatorAccessModel permission = new IndicatorAccessModel( psession );
   
   String deleteIndicatorURL = request.getContextPath() + "/KriIndicator.do?method=delete";
   String deleteIndicatorColumn = bundle.getString( "kri.IndicatorQuery.deleteIndicator.title" );

   String createRequestColumn = bundle.getString( "kri.IndicatorQuery.createRequest.title" );

   String deleteMsg = ApplicationProperties.getProperty("Kri.delete.confirm.txt",locale);
   String encodedMsg = com.sas.oprisk.framework.server.util.ParsingUtils.escape(deleteMsg);

   // check permissions
   boolean canDeleteIndicators = permission.userCanDelete();
   boolean canCreateRequests = permission.userCanCreateRequests();
   
   java.util.Map formatters = new java.util.HashMap();
   MonitorContext mc = MonitorContext.getMonitorContext(request);
   KriDecimalsCellFormatter rangeFormatter = new KriDecimalsCellFormatter(mc);
   
   formatters.put("rangeMid1", rangeFormatter);
   formatters.put("rangeMid2", rangeFormatter);
   formatters.put("x_target", rangeFormatter);
   formatters.put("rangeMax", rangeFormatter);
   formatters.put("rangeMin", rangeFormatter);
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      function createRequest(handle) {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/KriRequest.do"
               + "?method=create"
               + "&kriHandle=" + encodeURI(handle);
         f.submit();
      }
      
      function confirmDelete()
      {
        var msg = unescape('<%=encodedMsg%>')
        return confirm(msg)
      }
      
      function deleteIndicator(handle) {
         if (confirmDelete()) {
            var f = document.forms.queryForm;
            f.action = '<%= deleteIndicatorURL %>' 
            + '&handle=' + encodeURI(handle);
            f.submit();
         }
      }
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/IndicatorQuery">      
         <mon:ToolBar>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="indicator" columnFormatters="<%= formatters %>" disableTableActions="true" >

            <% if ( canDeleteIndicators ) { %>
              <mon:fixedColumn width="1%" before="false" title="<%= deleteIndicatorColumn %>" >
            
            <%  
                final KriEx indicator = (KriEx) pageContext.findAttribute("indicator");
                if ( indicator.canBeDeleted( psession ) && indicator.can( Do.DELETE, psession ) ) { %>
                  <a href="#" onclick="deleteIndicator('<c:out value='${indicator.handleString}'/>')">
                     <img border="0" style="border:0px;"
                        src="<%= request.getContextPath() %>/<fmt:message key='application.delete.image'/>" 
                        alt="<fmt:message key='application.delete.tooltip.txt'/>"
                        title="<fmt:message key='application.delete.tooltip.txt'/>"
                  /></a>
            <%   } else { %>
            &nbsp;
            <%   } %>
            
              </mon:fixedColumn>
            <% } %>
            
            <% if ( canCreateRequests ) { %>
            
              <mon:fixedColumn width="1%" before="false" title="<%= createRequestColumn %>" >
            <%
               final KriEx indicator = (KriEx) pageContext.findAttribute("indicator");
            %>
            <% if ( !indicator.getLocation(psession).isBottom() && indicator.canCreateRequests( psession ) ) { %>
                  <a href="#" onclick="createRequest('<c:out value='${indicator.handleString}'/>')">
                     <img border="0" style="border:0px;"
                        src="<%= request.getContextPath() %>/<fmt:message key='kri.DefinitionQuery.createNew.image'/>" 
                        alt="<fmt:message key='application.create.tooltip.txt'/>"
                        title="<fmt:message key='application.create.tooltip.txt'/>"
                  /></a>
            <% } else { %>
            &nbsp;
            <% } %>
              </mon:fixedColumn>
            <% } %>
            
            </mon:tableComponent>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
