<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.framework.server.objects.Do" %>
<%@ page import="com.sas.oprisk.monitor.web.kri.requests.*" %>
<%@ page import="java.util.*" %>

<%
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final ObservationRequestAccessModel permission = new ObservationRequestAccessModel( psession );
   
   String createNewFromColumn = bundle.getString( "kri.ObservationRequestQuery.createNewFrom.title" );
   String deleteRequestColumn = bundle.getString( "kri.ObservationRequestQuery.deleteRequest.title" );

   String createNewFromUrl = request.getContextPath() + "/KriRequest.do?method=createNewFrom";
   String deleteRequestUrl = request.getContextPath() + "/KriRequest.do?method=delete";
   String deleteMsg = ApplicationProperties.getProperty("KriObservationRequest.delete.confirm.txt",locale);
   String encodedMsg = com.sas.oprisk.framework.server.util.ParsingUtils.escape(deleteMsg);

   // check permissions
   boolean canCreateRequests = permission.getUserCanCreate();
   boolean canDeleteRequests = permission.getUserCanDelete();
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      function createNewFrom(handle) {
         var f = document.forms.queryForm;
         f.action = '<%= createNewFromUrl %>'
               + "&handle=" + encodeURI(handle);
         f.submit();
      }
      
      function confirmDelete()
      {
        var msg = unescape('<%=encodedMsg%>')
        return confirm(msg)
      }
      
      function deleteRequest(handle) {
        if (confirmDelete()) {
          var f = document.forms.queryForm;
          f.action = '<%= deleteRequestUrl %>' + "&handle=" + encodeURI(handle);
          f.submit();
        }
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/KriObservationRequestQuery">      
         <mon:ToolBar>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="obsRequest" disableTableActions="true" >
            
            <%
            final KriObservationRequestEx obsRequest = (KriObservationRequestEx)pageContext.findAttribute("obsRequest");
            %>
            
            
            <% if ( canDeleteRequests ) { %>
            
            <mon:fixedColumn width="1%" before="false" title="<%= deleteRequestColumn %>" >
            <% if ( obsRequest.userCanDelete( psession ) ) { %>
            
                  <a href="#" onclick="deleteRequest('<c:out value='${obsRequest.handleString}'/>')">
                     <img border="0" style="border:0px"
                        src="<%= request.getContextPath() %>/<fmt:message key='application.delete.image'/>" 
                        alt="<fmt:message key='application.delete.tooltip.txt'/>"
                        title="<fmt:message key='application.delete.tooltip.txt'/>"
                  /></a>
            <% } else { %>
            &nbsp;
            <% } %>
            
            </mon:fixedColumn>
            
            <% } %>
            
            <% if ( canCreateRequests ) { %>
            
            <mon:fixedColumn width="1%" before="false" title="<%= createNewFromColumn %>" >
            
            <% if ( !obsRequest.getLocation(psession).isBottom() && obsRequest.getKriActiveFlg().booleanValue() && obsRequest.can( Do.CREATE, psession ) ) { %>
                  <a href="#" onclick="createNewFrom('<c:out value='${obsRequest.handleString}'/>')">
                     <img border="0" style="border:0px"
                        src="<%= request.getContextPath() %>/<fmt:message key='KriObservationRequest.createNewFrom.image'/>" 
                        alt="<fmt:message key='application.create.tooltip.txt'/>"
                        title="<fmt:message key='application.create.tooltip.txt'/>"
                  /></a>
            <% } else { %>
            &nbsp;
            <% } %>
            
            </mon:fixedColumn>
            
            <% } %>
            
            </mon:tableComponent>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>

