<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   Map colFormatters = (Map)request.getAttribute("colFormatters");

   PersistenceSession psession = MonitorContext.getPersistenceSession(request);   
   boolean canCreate = SecurityUtils.canDoSomewhere(Do.CREATE, Audit.object, psession);
   boolean canDelete = SecurityUtils.canDoSomewhere(Do.DELETE, Audit.object, psession);
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      function createAudit() {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/Audit.do"
               + "?method=create";
         f.LOCATION.value = f.TCArea.value;
         f.submit();
      }
      
      function createNewAuditFrom(handle) {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/Audit.do"
               + "?method=createNew&handle=" + encodeURI(handle);
         f.submit();
      }
      
      function showCIContextMenu(handle, name) {
         var menu = new TableMenu();
         menu.addMenuItem(
            new MenuItem(
               MenuItem.prototype.action,
               "<fmt:message key='application.createNewFrom.image'/>", 
               "<fmt:message key='application.createNewFrom.txt'/>", 
               "javascript:createNewAuditFrom('" + handle + "')",
               <%= canCreate %>));
         menu.addMenuItem(
            new MenuItem(
               MenuItem.prototype.action,
               "<fmt:message key='application.delete.image'/>", 
               "<fmt:message key='application.delete.txt'/>", 
               "javascript:deleteAudit('" + handle + "','" + name + "')",
               <%= canDelete %>));      
         menu.render();
         return false;
      }
      
      function deleteAudit( auditHandle, name) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
            "audit.delete.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, unescape(name));
         if (confirm(msg)) {                 
            var f = document.forms.queryForm;
            f.action =
            "<%= request.getContextPath() %>/Audit.do"
               + "?method=delete&handle=" + encodeURI(auditHandle);
            f.submit();
         } 
      }
   
   </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/AuditQuery">      
         <mon:ToolBar>
            <% if (canCreate){ %> 
               <a class="toolBarAction" href="#" onclick="createAudit(); return false;"><fmt:message key='audit.createNewAudit.txt'/></a>
            <% } %>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent columnFormatters="<%=colFormatters%>" id="audit" disableTableActions="true" >
            <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%" >
               <%
                   Audit audit = (Audit)pageContext.findAttribute("audit");
                   String auditNm = audit == null ? "" : ParsingUtils.escape(audit.getAuditNm());
                   String handleString = audit == null ? "" : audit.getHandleString();
               %>
               &nbsp;<a href="#" onclick="return showCIContextMenu('<%= handleString %>', '<%= auditNm %>')"
               ><img border="0"
                   src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                  alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                  title="<fmt:message key='application.rowActions.tooltip.txt'/>"
               /></a>&nbsp;
            </mon:fixedColumn>
         </mon:tableComponent>
         <input type="hidden" name="LOCATION" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>