<%@page import="com.sas.oprisk.monitor.web.audit.component.AuditControlsTableComponent"%>
<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.audit.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.framework.server.objects.Do" %>
<%@ page import="com.sas.oprisk.server.behavior.SecurityUtils" %>
<%@ page import="com.sas.oprisk.server.TestPlan" %>
<%@ page import="com.sas.oprisk.server.Audit" %>

<%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
   final AuditModel model = (AuditModel)request.getAttribute(AuditAction.ATTR_MODEL);
   final String statusFilter=(String)request.getAttribute(AuditControlsTableComponent.PARAM_STATUS_FILTER);
   
   final String auditHandle;
   final Audit audit;
   final boolean readOnly;
   final boolean canCreateTests;
   
   if (model == null)
   {
      auditHandle = "";
      audit = null;
      readOnly = true;
      canCreateTests = false;
   }
   else
   {
      auditHandle = model.getHandleString();
      audit = model.getAudit();
      readOnly = model.isReadOnly();
      canCreateTests = !audit.isFresh() && SecurityUtils.canDoSomewhere(Do.CREATE, TestPlan.object, psession);
   }
%>

<script type="text/javascript">
   function addControls() {
       var tdORA = document.forms[0].LOCATION.value;   
       if(tdORA==null || tdORA==''){
          alert("<fmt:message key='testDefinition.controlsByRisk.error.noORA.txt'/>");
          return;
       }
       openModal(
            "<%= request.getContextPath() %>" 
            + "/AuditControlInstancesQuery.do?tdHandle="
            + encodeURI(document.forms[0].handle.value)
            <%if(statusFilter!=null){%>
            + "&statusFilter=<%=statusFilter%>"
            <%}%>
            + "&TCArea=" + encodeURI(document.forms[0].LOCATION.value),
            "controlInstancesPopup", 
            "width=680,height=480,scrollbars,resizable,status");
   }
   
   function addControlsByRisk() {     
      var tdORA = document.forms[0].LOCATION.value;   
      if(tdORA==null||tdORA==''){
         alert("<fmt:message key='testDefinition.controlsByRisk.error.noORA.txt'/>");
         return;
      }
         openModal(
            "<%= request.getContextPath() %>" 
            + "/ControlInstancesByRiskQuery.do?tdHandle=" 
            + encodeURI(document.forms[0].handle.value)
            <%if(statusFilter!=null){%>
            + "&statusFilter=<%=statusFilter%>"
            <%}%>
            + "&risks_TCArea=" + encodeURI(tdORA)
            + "&tdAreaHandle=" + encodeURI(tdORA),
            "controlInstancesByRiskPopup");     
   }
   
   //method to add the selected controls from "Add Controls" window and refresh the current Test Definition screen.
   //Invoked on clicking the "Add" or "Add and Close" buttons.
   function addSelectedControls(selectionArray) {
      // store selection array in hidden field
      document.forms.auditForm.controlsToAddorRemove.value = selectionArray;
      
      // submit form and add selected controlds
      callMethod("addControls");
   }
   
   function showCIContextMenu(handle, name, canUnlinkControl) {
      var menu = new TableMenu();
      menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<fmt:message key='application.remove.image'/>", "<fmt:message key='application.remove.txt'/>", "javascript:removeControl('" + handle + "','" + name + "')"));      
      menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<fmt:message key='application.createNewFrom.image'/>", "<fmt:message key='audit.createTests.txt'/>", "javascript:createTestsFromControlInstance('" + handle + "')"));
      menu.render();
      return false;
   }
   
   function removeControl( ciHandle, name) {
      var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
         "TestDefinition.removeControl.confirm.message.fmt.txt")) %>");
      msg = formatMessage(msg, unescape(name));
      if (confirm(msg)) {                 
         document.forms.auditForm.controlsToAddorRemove.value = ciHandle;
         callMethod("removeControl");
      } 
   }
   
   function createTestsFromControlInstance( ciHandle ){
      openModal(
         "<%= request.getContextPath() %>" 
         + "/AuditCreateTestsQuery.do?ciHandle="
         + encodeURI(ciHandle),
         "auditCreateTestsPopup", 
         "width=680,height=480,scrollbars,resizable,status");
   }
   
   function createTests(ciHandle, selectionArray) {
      // store selection array in hidden field
      document.forms.auditForm.selectedTestDefns.value = selectionArray;
      
      var f = document.forms.auditForm;
      f.action = "<%= request.getContextPath() %>/Audit.do?method=forward"
         + "&<%= AuditAction.AUDIT_INSTANCE_HANDLE %>=" + encodeURI('<%= auditHandle %>') 
         + "&path=/CreateTests.do?method=createTestsFromAudit&ciHandle=" + encodeURI(ciHandle);
      f.submit();
   }
   
   function showControlInstance(handle) {    
      openModal(
         "<%= request.getContextPath() %>" 
         + "/ControlInstance.do?method=select&handle="
         + handle + "&readOnly=true&popup=true",
         "controlInstancePopup", 
         "width=650,height=450,scrollbars,resizable,status"
      );
   }
   
   function showRiskInstance(handle) {
      openModal(
         "<%= request.getContextPath() %>" 
         + "/RiskInstance.do?method=select&handle="
         + handle + "&readOnly=true&popup=true",
         "riskInstancePopup", 
         "width=650,height=450,scrollbars,resizable,status"
      );
   }
   
</script>

<input type="hidden" name="controlsToAddorRemove" />
<input type="hidden" name="selectedTestDefns" />

<mon:tableComponent entryName="controls" id="control" wizCursor="refresh"  >
   
   <%
      if (!readOnly){
         final ControlInstance entry = (ControlInstance)pageContext.findAttribute("control");
         String controlName = entry != null ? ParsingUtils.escape(entry.getControlInstNm()) : "";
         boolean canUnlinkControl = ! readOnly;
   %>
      <mon:action href='javascript:addControls()'><fmt:message key='testDefinition.title.controls.add.txt'/></mon:action>&nbsp;|&nbsp;
      <mon:action href='javascript:addControlsByRisk()'><fmt:message key='testDefinition.title.controls.addByRisk.txt'/></mon:action>&nbsp;|&nbsp;
      
      <% if (canCreateTests) { %>
      <mon:fixedColumn before="false" title='<%= bundle.getString("audit.createTests.txt") %>' >
         <a href="javascript:createTestsFromControlInstance('<c:out value='${control.handleString}'/>')">
            <img border="0" src="<%=ThemedImage.NEW_ELEMENT.getURL(request)%>"  
                 alt="<fmt:message key='audit.createTests.tooltip.txt'/>" 
                 title="<fmt:message key='audit.createTests.tooltip.txt'/>"/></a>
      </mon:fixedColumn>
      <% } %>
      
      <mon:fixedColumn width="1%" before="false" title='<%= bundle.getString("application.remove.txt") %>' >
         <a href="javascript:removeControl('<c:out value='${control.handleString}'/>', '<%= ParsingUtils.escape(controlName) %>')">
            <img border="0" src="<fmt:message key='application.remove.image' />"  
                 alt="<fmt:message key='application.remove.tooltip.txt'/>" 
                 title="<fmt:message key='application.remove.tooltip.txt'/>"/></a>
      </mon:fixedColumn>
   <%
      }
   %>
</mon:tableComponent>
<c:if test="${hasInvisibleControls}">
   <mon:InfoMessage>
      <fmt:message key="linkedBusinessObjects.hasInvisibleItems.txt"/>
   </mon:InfoMessage>
</c:if>