<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.table.DateCellFormatter" %>
<%@ page import="com.sas.oprisk.server.*" %>

<%    
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   String context = request.getContextPath();
   
   MonitorContext mc = MonitorContext.getMonitorContext(request);
   java.util.Map formatters = new java.util.HashMap();
   formatters.put("creationDttm", new DateCellFormatter(mc));
%>

<mon:Page template="default">
   <mon:Head>
      <mon:include js="/script/modalPopup.js" />
      <mon:include js="/ext/cpbcore/browser/Event.js" />
      <script type="text/javascript">
      
         function getForm() {
            return document.forms.queryForm;
         }     
         function createTestDefinitionGroup() {
            var f = getForm();
            f.action =
               "<%= request.getContextPath() %>/TestDefinitionGroupEditor.do" 
               + "?method=create";     
            f.submit();
         }
         function createTests( handle ) {
               var f = getForm();
               f.action =
                  "<%= request.getContextPath() %>/CreateTests.do" 
                  + "?method=createTestsFromGroup"
                  + "&handle=" + encodeURI(handle);     
               f.submit();
         }
         
         function deleteTestDefinitionGroup(handle, name) {
            var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
                  "testDefinitionGroupTable.removeGroup.confirm.fmt.txt")) %>");
            msg = formatMessage(msg, unescape(name));
            if (confirm(msg)) {
               doAction("delete", handle);
            }
         }     
            
         function doAction(method, handle) {
            beginWait();
            var f = getForm();
            f.action = "<%= request.getContextPath() %>/TestDefinitionGroupEditor.do"
               + "?method=" + method
               + "&handle=" + encodeURI(handle);
            f.submit();
         }
      
         function showContextMenu( handle, name, isActive, hasDefinitions, canBeDeleted ) {
               var menu = new TableMenu();
         
               if ( isActive ) {
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<%= context %>/<fmt:message key='application.deactivate.image'/>", 
               "<fmt:message key='testDefinitionGroupTable.deactivateGroup.txt'/>", "javascript:doAction('deactivate', '" + handle + "')" ));
               } else {
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<%= context %>/<fmt:message key='application.activate.image'/>", 
               "<fmt:message key='testDefinitionGroupTable.reactivateGroup.txt'/>", "javascript:doAction('reactivate', '" + handle + "')" ));
               }
               <c:if test="${canCreate}" >
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<%= context %>/<fmt:message key='application.createNewFrom.image'/>", 
               "<fmt:message key='testDefinitionGroupTable.createNewGroupFrom.txt'/>", "javascript:doAction('createFromGroup', '" + handle + "')" ));
               </c:if>
               if ( canBeDeleted ) {
            menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<%= context %>/<fmt:message key='application.delete.image'/>", 
               "<fmt:message key='application.delete.txt'/>", "javascript:deleteTestDefinitionGroup('" + handle + "', '" + name + "')" ));
               }
         
            menu.render();
            return false;
         }
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/TestDefinitionGroupsQuery">      
         <mon:ToolBar>
            <c:if test="${canCreate}" >
               <a class="toolBarAction" href="#" id="createTestDefinitionGroupLink" onclick="createTestDefinitionGroup(); return false;"><fmt:message key='controlTesting.createTestDefinitionGroup.button.txt'/></a>      
            </c:if>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="group" columnFormatters="<%= formatters %>" disableTableActions="true" >
            <mon:title><fmt:message key="controlTesting.TestDefinitionGroupsQuery.title"/></mon:title>
           
      
           <c:if test="${canCreate || canUpdate || canDelete}" >
           <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
      <%
      final TestDefinitionGroupEx group = (TestDefinitionGroupEx) pageContext.findAttribute("group");
      final String escName = ParsingUtils.escape(group.getName());
      final boolean isActive = group.getActiveFlg().booleanValue();
      final boolean canBeDeleted = group.can( Do.DELETE, psession );
      final boolean hasDefinitions = group.getTestDefnCnt().intValue() > 0;
      %>
            &nbsp;<a href="#" onclick="return showContextMenu('<c:out value='${group.handleString}'/>', '<%= escName %>', <%= isActive %>, <%= hasDefinitions %>, <%= canBeDeleted %>)"
               ><img border="0"
                   src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                  alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                  title="<fmt:message key='application.rowActions.tooltip.txt'/>"
           /></a>&nbsp;
           </mon:fixedColumn>
           </c:if>
           
           <c:if test="${canCreateTests}">
           <mon:fixedColumn before="false" title='<%= bundle.getString("testDefinitionGroupTable.createNewTestsFrom.txt") %>' >            
           <c:if test="${group.activeFlg}">
                     <a href="javascript:createTests('<c:out value="${group.handleString}"/>') ">
                     <img border="0" src="<fmt:message key='application.createNew.image' />"  
                          alt="<fmt:message key='application.create.tooltip.txt'/>" 
                          title="<fmt:message key='application.create.tooltip.txt'/>"/>
                     </a>
           </c:if>
           <c:if test="${not group.activeFlg}">&nbsp;
           </c:if>
           </mon:fixedColumn>     
           </c:if>
        </mon:tableComponent>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
