<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   CustomObjectMetaData customObjectMetaData= (CustomObjectMetaData)request.getAttribute("customObjectMetaData");
   String businessObjectTypeNm=customObjectMetaData.getClassObject().getBusinessObjectTypeName();
   PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   Map colFormatters = (Map)request.getAttribute("colFormatters");
   boolean canCreate = (Boolean)request.getAttribute("canCreate");
   boolean canDelete = (Boolean)request.getAttribute("canDelete");
   pageContext.setAttribute("canCreate", new Boolean(canCreate));
   String createButtonLabel=bundle.getString(businessObjectTypeNm +".create.button");
   String deleteMsg=ApplicationProperties.getMessage(businessObjectTypeNm +".delete.confirm.message.fmt.txt", locale);
   String pointerTag=customObjectMetaData.getClassObject().getPointerTag();
%>

<mon:Page template="default">
   <mon:Head>
      <mon:include js="/dwr/engine.js"/>
      <mon:include js="/dwr/util.js"/>
      <mon:include js="/dwr/interface/CommonService.js"/>
      
      <script type="text/javascript">

         function createCustomObject()
         {
            var form = document.forms.queryForm;
            form.action = "<%= request.getContextPath() %><%=customObjectMetaData.getCPBEditorServletPath()%>?method=create";
            form.LOCATION.value = form.TCArea.value;
            form.submit();
         }
         
         function deleteCustomObject( customObjectHandle, name ) {
            var msg = unescape("<%= ParsingUtils.escape(deleteMsg) %>");
            msg = formatMessage(msg, unescape(name));
            if (confirm(msg)) {
               doAction('delete', customObjectHandle);
            } 
         }
      
         function showContextMenu(handle, name)
          {
        	
        	
            CommonService.getWorkableActivitiesJSONString(
               "<%= pointerTag %>|" + handle,
               
               function(jsonStr)
               {
                  var array = eval('(' + jsonStr + ')');
                  var menu = new TableMenu();
                  for (var i = 0; i < array.length; i++)
                  {
                     menu.addMenuItem(
                        new MenuItem(
                           MenuItem.prototype.action,
                           "<%= request.getContextPath() %>/" + "<fmt:message key='application.viewdata.image'/>", 
                           array[i].label + "<fmt:message key='application.ellipsis.txt'/>",
                           array[i].url, 
                           true));
                  }
                  if (<%= canCreate %> || <%= canDelete %>)
                  {
                     menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
                  }
                  if (<%= canCreate %>)
                  {
                     menu.addMenuItem(
                        new MenuItem(
                           MenuItem.prototype.action,
                           "<%= request.getContextPath() %>/" + "<fmt:message key='application.createNewFrom.image'/>", 
                           "<fmt:message key='application.createNewFrom.tooltip.txt'/>", 
                           "javascript:doAction('createNewFrom', '" + handle + "')", 
                           <%= canCreate %>));
                  }
                  if (<%= canDelete %>)
                  {
                     menu.addMenuItem(
                        new MenuItem(
                           MenuItem.prototype.action,
                           "<%= request.getContextPath() %>/" + "<fmt:message key='application.delete.image'/>", 
                           "<fmt:message key='application.deleteElipses.txt'/>", 
                           "javascript:deleteCustomObject('" + handle + "', '" + name + "')", 
                           <%= canDelete %>));
                  }
                  menu.render();
               }
            );
            return false;
         }
         
         function doAction(method, handle)
         {
            beginWait();
            var form = document.forms.queryForm;
            form.action = "<%= request.getContextPath() %><%=customObjectMetaData.getCPBEditorServletPath()%>"
               + "?method=" + method
               + "&handle=" + encodeURI(handle);
            form.submit();
         }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="<%= customObjectMetaData.getQueryServletPath()%>">
         <mon:ToolBar>
            <c:if test="${canCreate}">
               <a class="toolBarAction" href="#" id="createCustomObjectButton" onclick="createCustomObject(); return false;">
                 <% out.println(createButtonLabel); %>
               </a>
            </c:if>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <input type="hidden" name="LOCATION"/>
   
            <mon:tableComponent columnFormatters="<%= colFormatters %>" id="customObject" disableTableActions="true" >
               <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
                  &nbsp;
                  <%
                     CustomObject customObject = (CustomObject)pageContext.findAttribute("customObject");
                     String customObjectNm = customObject == null ? "" : ParsingUtils.escape(customObject.getCustObjNm());
                     String handleString = customObject == null ? "" : customObject.getHandleString();
                  %>
                  <a href="#" onclick="return showContextMenu('<%= handleString %>', '<%= customObjectNm %>')">
                     <img border="0"
                          src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                          alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                          title="<fmt:message key='application.rowActions.tooltip.txt'/>"/>
                  </a>
                  &nbsp;
               </mon:fixedColumn>
            </mon:tableComponent>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>

