<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%
   Locale locale = request.getLocale();
   ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   Map colFormatters = (Map)request.getAttribute("colFormatters");
   boolean canDelete = SecurityUtils.canDoSomewhere(Do.DELETE, Obligation.object, psession);
   
   boolean changeReasonRequired = ConfigDataProperties.isChangeReasonRequired();
   String deleteConfirmMsg = ParsingUtils.escape(bundle.getString("obligation.delete.confirm.message.txt"));
%>

<mon:Page template="default">
   <mon:Head>      
      <script type="text/javascript">
      
      function createObligation() {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/ObligationAction.do"
               + "?method=create";
         f.LOCATION.value = f.TCArea.value;
         f.submit();
      }
      
      function doAction(method, handle)
      {
      <% if (!changeReasonRequired) { %>
         var msg = unescape('<%= deleteConfirmMsg %>');
         if (!confirm(msg)) {
            return;
         }
      <% } %>

         var form = document.forms.queryForm;
         form.action = "<%= request.getContextPath() %>/ObligationAction.do"
            + "?method=" + method
            + "&handle=" + encodeURI(handle);
         form.submit();
      }
      
      </script>      
   </mon:Head>
   <mon:Body>      
      <html:form action="/ObligationQuery">
         <mon:ToolBar>
            <c:if test="${canCreate}">
               <a class="toolBarAction" href="#" id="createObligationLink" onclick="createObligation(); return false;"><fmt:message key='obligation.create.action.label'/></a>
            </c:if>
            <mon:SavedView></mon:SavedView>
         </mon:ToolBar>
         <mon:Content>
            
            <mon:tableComponent columnFormatters="<%=colFormatters%>" id="obligation" >
               
<%
   if (canDelete)
   {
      Obligation entry = (Obligation)pageContext.findAttribute("obligation");
%>
               <mon:fixedColumn title='<%= bundle.getString("application.delete.txt") %>' width="1%" before="false">
                  &nbsp;
                  <a href="javascript:doAction('delete', '<%= entry.getHandleString() %>')">
                     <img border="0"
                          src="<%= request.getContextPath() %>/<fmt:message key='application.delete.image'/>" 
                          alt="<fmt:message key='application.delete.txt'/>"
                          title="<fmt:message key='application.deleteElipses.txt'/>"/>
                  </a>
                  &nbsp;
               </mon:fixedColumn>
<%
   }
%>
            </mon:tableComponent>
            
            <input type="hidden" name="LOCATION" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
