<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.server.User" %>
<%@ page import="com.sas.solutions.cpb.framework.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.validation.ValidationModel" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag" %>
<%@ page import="com.sas.oprisk.monitor.web.user.forms.*" %>

<%-- ****************************************************************** --%>
<%-- UserEditor.jsp --%>
<%-- ****************************************************************** --%>

<%    
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final UserFormEx userForm = (UserFormEx)pageContext.findAttribute("userFormEx");
   final User user = (User)request.getAttribute("user");
   final boolean readOnly = !Boolean.TRUE.equals(request.getAttribute("canSave"));
%>

<mon:Page template="details">
   <mon:Head>
      <script type="text/javascript">
      function performAction( actionName ) {
              document.forms.userFormEx.action = 
                      "<%= request.getContextPath()+'/' %>"
              + encodeURI(actionName);
          document.forms.userFormEx.submit();
      }
      
      function removePosition(handle, name){
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
            "user.removePosition.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, unescape(name));
         if (confirm(msg)) {
            performAction('UserAddPosition.do?method=delete&positionHandle=' + handle);
         }
      }
      </script>
      
      <style type="text/css" >
      .displayTable {
         width: 100%;
      }
      </style>
   </mon:Head>
   <mon:Body>      
      <html:form action="/UserSave">      
         <mon:ToolBar>
            <% if (!readOnly) { %>
               <mon:Button name="saveButton" onclick="performAction('UserSave.do')">
                  <fmt:message key='saveButton.txt' />
               </mon:Button>
               
               <mon:Button name="cancelButton" onclick="performAction('UserCancel.do')">
                  <fmt:message key='cancelButton.txt' />
               </mon:Button>
                        
             <% } else { %>
               <mon:Button name="returnButton" onclick="performAction('UserCancel.do')">
                  <fmt:message key='returnButton.txt' />
               </mon:Button>
             <% } %>
         </mon:ToolBar>
         
         <mon:Content>
            <html:hidden property="handle" />
            <html:hidden property="userRk" />
            
            <input type="hidden" name="page.title" value="<c:out value="${requestScope.title}" />" />
         
            <table border="0">
                    <tr id="User_userId">
                       <th class="fieldlabel">
                          <mon:label separatorVisible="true" key="user.field.userId.displayName.txt" />
                       </th>
                       <td class="field">
                           <c:out value="<%= user.getUserId()%>" />
                       </td>
                    </tr>
         
                    <tr id="User_displayNm">
                       <th class="fieldlabel">
                          <mon:label separatorVisible="true" key="user.field.displayNm.displayName.txt" />
                       </th>
                       <td class="field"> 
                          <c:out value="<%= user.getDisplayNm()%>" />
                       </td>
                    </tr>
                    
                    <tr id="User_titleTxt">
                       <th class="fieldlabel">
                          <mon:label separatorVisible="true" key="user.field.titleTxt.displayName.txt" />
                       </th>
                       <td class="field"> 
                          <c:out value="<%= user.getTitleTxt()%>" />
                       </td>
                    </tr>
         
                    <tr id="User_emailTxt">
                       <th class="fieldlabel">
                          <mon:label separatorVisible="true" key="user.field.emailTxt.displayName.txt" />
                       </th>
                       <td class="field">
                           <c:out value="<%= user.getEmailTxt()%>" />
                       </td>
                    </tr>
         
                    <tr id="User_phone">
                       <th class="fieldlabel">
                          <mon:label separatorVisible="true" key="user.field.phone.displayName.txt" />
                       </th>
                       <td class="field">
                           <c:out value="<%= user.getPhone()%>" />
                       </td>
                    </tr>
                            
                    <tr id="User_activeFlg">
                       <th class="fieldlabel">
                          <mon:label separatorVisible="true" key="user.field.activeFlg.displayName.txt" />
                       </th>
                       <td class="field"> 
                          <%= user.getActiveFlg().booleanValue() ?
                                   bundle.getString("yesno.yes.txt")
                                 : bundle.getString("yesno.no.txt") %>
                       </td>
                    </tr>
         
                    <tr id="User_confidentialityCd">
                       <%-- security clearance / confidentiality --%>
                       <th class="fieldlabel">
                          <mon:label separatorVisible="true" property="confidentialityCd" 
                            key="user.field.confidentialityCd.displayName.txt" />
                       </th>
                       <td class="field"> 
                          <mon:select property="confidentialityCd">
                             <html:optionsCollection
                                property="confidentialities"
                                label="description" value="code" />
                          </mon:select>
                       </td>
                    </tr>
                    <mon:CustFields 
                       propertyKey="user" 
                       readOnly="user" 
                       format="table"
                       inOwnTable="false" />
                 </table>
         <%
         if(ConfigDataProperties.getShowLinkedBusinessObjectsOnUser())
         {
         %>
            <br/>
            <mon:LinkedBusinessObjects sourceBusinessObject="<%=user%>" readOnly="<%=readOnly%>" />
         <%
         }
         %>
         <br/>
         <mon:DimPointChooser 
            property="dimensionalPoint"
            feature="<%= BusinessObjectFeatureInfo.USER.getFeatureName() %>"
            rootVisible="false"
            readOnly="false">
            <mon:title><fmt:message key="user.field.dimensionalPoint.displayName.txt" /></mon:title>
         </mon:DimPointChooser>
         <br/>
              <div id="User_assignedPositions">
               <mon:table cellspacing="0" class="displayTable" name="assignedPositions" id="position">
                  <mon:title><fmt:message key="userForm.section.assignedPositions.txt"/></mon:title>
                  
                  <c:if test="${canAddPositions}">
                  <mon:action href="javascript:performAction('UserAddPosition.do')">
                     <fmt:message key='application.add.txt'/>
                  </mon:action>
                  </c:if>
                  <display:column title='<%= bundle.getString("userForm.column.role.txt") %>' >
                  <a href="javascript:performAction('UserAddPosition.do?method=select&positionHandle=<%= ((Position)position).getHandleString() %>')">
                      <%= ((Position)position).getRole(psession).getName() %>
                  </a>
                  </display:column>
                  <display:column title='<%= bundle.getString("userForm.column.scope.txt") %>'>
                  <a href="javascript:performAction('UserAddPosition.do?method=select&positionHandle=<%= ((Position)position).getHandleString() %>')">
                      <%= ((Position)position).getLocation(psession).formatHtml(psession) %>
                  </a>
                  </display:column>
               
                  <% if (Boolean.TRUE.equals(request.getAttribute("canDeletePositions"))) { %>
                  <display:column width='1%' title='<%= bundle.getString("application.remove.txt") %>' align='center' headerClass="nwc">
                          <% if (((Position)position).can(com.sas.oprisk.framework.server.objects.Do.DELETE, psession)) { %>
                               <a href="javascript:removePosition('<%= ((Position)position).getHandleString() %>', '<%= ((Position)position).getRole(psession).getName() %>')">
                                  <img border="0" src="<fmt:message key='application.remove.image'/>"
                                      alt="<fmt:message key='application.remove.tooltip.txt'/>" 
                                      title="<fmt:message key='application.remove.tooltip.txt'/>"/></a>
                          <% } %>
                  </display:column>
                  <% } %>
               </mon:table>
               </div>
            <br />
             <div id="User_validationStages">            
            <mon:table cellspacing="0" class="displayTable" name="validationStages" id="stage">
               <mon:title><fmt:message key="userForm.section.assignedWorkflowStages.txt"/></mon:title>
               
               <display:column title='<%= bundle.getString("localValidationSequence.field.validationTypeCd.displayName.txt") %>'
                  property="objectType" />
                  
               <display:column title='<%= bundle.getString("ora.location.txt") %>'
                  property="location" />
                  
               <display:column title='<%= bundle.getString("validationStage.column.number.displayName.txt") %>'
                  property="orderNo" />
                  
               <display:column title='<%= bundle.getString("validationStage.column.name.displayName.txt") %>'
                  property="name" />
                
               <display:column title='<%= bundle.getString("validationStage.field.validationStageId.displayName.txt") %>'
                  property="validationStageId" />
                        
               <display:column title='<%= bundle.getString("validationStage.field.sourceSystemCd.displayName.txt") %>'
                  property="sourceSystem" />
            </mon:table>
            </div>
            <% if (!Boolean.TRUE.equals(request.getAttribute("canSave"))) { %>
         <script type="text/javascript">
           // disable all other form fields and buttons
           for(i = 0; i<document.forms.userFormEx.elements.length; i++) {
             if (document.forms.userFormEx.elements[i].type != "button") {
               document.forms.userFormEx.elements[i].disabled=true;
             }   
           }   
         </script> 
         <% } %>
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>



